using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

using Ringlet.Misc.VCS;

namespace Ringlet.Misc.Scramble.Unscramble
{
	/// <summary>
	/// Query the player for a name after achieving a high score.
	/// </summary>
	public class HighScoreName : System.Windows.Forms.Form, IVersioned
	{
		private System.Windows.Forms.Label lblText;
		private System.Windows.Forms.Label lblName;
		private System.Windows.Forms.TextBox txtName;
		private System.Windows.Forms.Button btnAdd;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		
		/// <summary>
		/// Initialize a HighScoreName form with default values.
		/// </summary>
		public HighScoreName()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
		}

		/// <summary>
		/// Get the version control system tag.
		/// </summary>
		public virtual string VCSTag
		{
			get
			{
				return ("$Ringlet: cs/misc/Scramble/Unscramble/HighScoreName.cs,v 1.1 2003/07/12 01:55:39 roam Exp $");
			}
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.lblText = new System.Windows.Forms.Label();
			this.lblName = new System.Windows.Forms.Label();
			this.txtName = new System.Windows.Forms.TextBox();
			this.btnAdd = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// lblText
			// 
			this.lblText.Location = new System.Drawing.Point(16, 16);
			this.lblText.Name = "lblText";
			this.lblText.Size = new System.Drawing.Size(256, 40);
			this.lblText.TabIndex = 0;
			// 
			// lblName
			// 
			this.lblName.Location = new System.Drawing.Point(16, 72);
			this.lblName.Name = "lblName";
			this.lblName.Size = new System.Drawing.Size(152, 16);
			this.lblName.TabIndex = 1;
			this.lblName.Text = "Enter your name:";
			// 
			// txtName
			// 
			this.txtName.Location = new System.Drawing.Point(16, 96);
			this.txtName.Name = "txtName";
			this.txtName.Size = new System.Drawing.Size(264, 20);
			this.txtName.TabIndex = 2;
			this.txtName.Text = "Unknown Player";
			// 
			// btnAdd
			// 
			this.btnAdd.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.btnAdd.Location = new System.Drawing.Point(72, 136);
			this.btnAdd.Name = "btnAdd";
			this.btnAdd.Size = new System.Drawing.Size(104, 32);
			this.btnAdd.TabIndex = 3;
			this.btnAdd.Text = "Add high score!";
			// 
			// HighScoreName
			// 
			this.AcceptButton = this.btnAdd;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 173);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
											  this.btnAdd,
											  this.txtName,
											  this.lblName,
											  this.lblText});
			this.Name = "HighScoreName";
			this.Text = "Congratulations!";
			this.Load += new System.EventHandler(this.HighScoreName_Load);
			this.ResumeLayout(false);

		}
		#endregion

		private void HighScoreName_Load(object sender, System.EventArgs e)
		{
			txtName.SelectAll();
			txtName.Focus();
		}

		/// <summary>
		/// Set the number of moves the player has made.
		/// </summary>
		public int Moves
		{
			set
			{
				lblText.Text = String.Format(
@"Congratulations!
With {0} moves, you achieved a high score entry!",
				    value);
			}
		}

		/// <summary>
		/// Get the player name entered.
		/// </summary>
		public string PlayerName
		{
			get
			{
				return (txtName.Text);
			}
		}
	}
}
