using System;

using Ringlet.Misc.VCS;

namespace Ringlet.Drawing.Scramble
{
	/// <summary>
	/// A structure representing a scrambled puzzle's fragment.
	/// </summary>
	public struct SCPuzzleFrag : IVersioned
	{
		/// <summary>
		/// The X coordinate of the fragment.
		/// </summary>
		public int x;
		/// <summary>
		/// The Y coordinate of the fragment.
		/// </summary>
		public int y;
		/// <summary>
		/// The X coordinate of the "real" image fragment.
		/// </summary>
		public int imx;
		/// <summary>
		/// The Y coordinate of the "real" image fragment.
		/// </summary>
		public int imy;

		/// <summary>
		/// Get the version control system tag.
		/// </summary>
		public string VCSTag
		{
			get
			{
				return ("$Ringlet: cs/misc/Scramble/libscpic/SCPuzzleFrag.cs,v 1.1 2003/07/10 14:38:29 roam Exp $");
			}
		}
	}
}
