-- $Ringlet: cs/misc/Scramble/libscpic/SQLUpdate/Scramble-lib-20030619.sql,v 1.4 2003/07/11 18:36:32 roam Exp $

CREATE TABLE dbo.scpics
	(
	pic_id int NOT NULL IDENTITY (1, 1),
	pic_fname varchar(255) NOT NULL,
	pic_date datetime NOT NULL,
	pic_slx int NOT NULL,
	pic_sly int NOT NULL,
	pic_inuse smallint NOT NULL,
	pic_fragdir varchar(255) NOT NULL,
	pic_fragprefix varchar(255) NOT NULL,
	pic_fragsuffix varchar(255) NOT NULL
	)  ON [PRIMARY]
GO
ALTER TABLE dbo.scpics ADD CONSTRAINT
	PK_scpics PRIMARY KEY CLUSTERED 
	(
	pic_id
	) ON [PRIMARY]

GO
ALTER TABLE dbo.scpics ADD CONSTRAINT
	IX_scpics UNIQUE NONCLUSTERED 
	(
	pic_fname,
	pic_date
	) ON [PRIMARY]

GO
CREATE UNIQUE NONCLUSTERED INDEX IX_scpics_1 ON dbo.scpics
	(
	pic_fname,
	pic_date
	) ON [PRIMARY]
GO

CREATE TABLE dbo.scfragments
	(
	frag_id int NOT NULL IDENTITY (1, 1),
	frag_pic int NOT NULL,
	frag_x int NOT NULL,
	frag_y int NOT NULL,
	frag_fname varchar(512) NOT NULL
	)  ON [PRIMARY]
GO
ALTER TABLE dbo.scfragments ADD CONSTRAINT
	PK_scfragments PRIMARY KEY CLUSTERED 
	(
	frag_id
	) ON [PRIMARY]

GO
ALTER TABLE dbo.scfragments ADD CONSTRAINT
	FK_scfragments_scpics FOREIGN KEY
	(
	frag_pic
	) REFERENCES dbo.scpics
	(
	pic_id
	) ON UPDATE CASCADE
	 ON DELETE CASCADE
	
GO

ALTER TABLE dbo.scpics ADD
	pic_name varchar(64) NOT NULL CONSTRAINT DF_scpics_pic_name DEFAULT '',
	pic_comment varchar(512) NOT NULL CONSTRAINT DF_scpics_pic_comment DEFAULT ''
GO

CREATE TABLE dbo.scpuzzles
	(
	pz_id int NOT NULL IDENTITY (1, 1),
	pz_pic int NOT NULL,
	pz_session varchar(255) NOT NULL,
	pz_moves int NOT NULL,
	pz_curx int NOT NULL,
	pz_cury int NOT NULL
	)  ON [PRIMARY]
GO
ALTER TABLE dbo.scpuzzles ADD CONSTRAINT
	PK_scpuzzles PRIMARY KEY CLUSTERED 
	(
	pz_id
	) ON [PRIMARY]

GO
ALTER TABLE dbo.scpuzzles ADD CONSTRAINT
	FK_scpuzzles_scpics FOREIGN KEY
	(
	pz_pic
	) REFERENCES dbo.scpics
	(
	pic_id
	) ON UPDATE CASCADE
	 ON DELETE CASCADE
	
GO

CREATE TABLE dbo.scpuzzlefrag
	(
	pzf_id int NOT NULL IDENTITY (1, 1),
	pzf_puzzle int NOT NULL,
	pzf_x int NOT NULL,
	pzf_y int NOT NULL,
	pzf_imx int NOT NULL,
	pzf_imy int NOT NULL
	)  ON [PRIMARY]
GO
ALTER TABLE dbo.scpuzzlefrag ADD CONSTRAINT
	PK_scpuzzlefrag PRIMARY KEY CLUSTERED 
	(
	pzf_id
	) ON [PRIMARY]

GO
CREATE NONCLUSTERED INDEX IX_scpuzzlefrag ON dbo.scpuzzlefrag
	(
	pzf_puzzle
	) ON [PRIMARY]
GO
ALTER TABLE dbo.scpuzzlefrag ADD CONSTRAINT
	FK_scpuzzlefrag_scpuzzles FOREIGN KEY
	(
	pzf_puzzle
	) REFERENCES dbo.scpuzzles
	(
	pz_id
	) ON UPDATE CASCADE
	 ON DELETE CASCADE
	
GO

CREATE TABLE [dbo].[scscores] (
	[sc_id] [int] IDENTITY (1, 1) NOT NULL ,
	[sc_name] [varchar] (255) COLLATE Cyrillic_General_CI_AS NOT NULL ,
	[sc_picture] [varchar] (255) COLLATE Cyrillic_General_CI_AS NOT NULL ,
	[sc_rows] [int] NOT NULL ,
	[sc_cols] [int] NOT NULL ,
	[sc_moves] [int] NOT NULL ,
	[sc_date] [datetime] NOT NULL 
) ON [PRIMARY]
GO
ALTER TABLE dbo.scscores ADD CONSTRAINT
	PK_scscores PRIMARY KEY CLUSTERED 
	(
	sc_id
	) ON [PRIMARY]

GO

