using System;
using System.Data;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.IO;
using System.Windows.Forms;

using Ringlet.Data.ConnectionUtil;
using Ringlet.Drawing.Scramble;
using Ringlet.Misc.VCS;

namespace Ringlet.Drawing.spictest
{
	/// <summary>
	/// The main form for the libspic test app
	/// </summary>
	public class TestMain : System.Windows.Forms.Form, IVersioned
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.TextBox txtX;
		private System.Windows.Forms.TextBox txtY;
		private System.Windows.Forms.TextBox txtFilename;
		private System.Windows.Forms.OpenFileDialog opFName;
		private System.Windows.Forms.Button btnBrowseFName;
		private System.Windows.Forms.Button btnCut;
		private System.Windows.Forms.PictureBox picWhole;
		private System.Windows.Forms.PictureBox picPart;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.TextBox txtImgID;
		private System.Windows.Forms.Button btnLoad;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		/// <summary>
		/// The SQL database connection settings.
		/// </summary>
		protected ConnectionProperties prop;

		/// <summary>
		/// The version control tag.
		/// </summary>
		virtual public string VCSTag { get { return "$Ringlet: cs/misc/Scramble/spictest/TestMain.cs,v 1.5 2003/07/10 14:38:58 roam Exp $"; } }

		/// <summary>
		/// Initialize a TestMain form.
		/// </summary>
		public TestMain()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			prop = new ConnectionProperties();
			prop.Server = "localhost";
			prop.Database = "scramble";
			prop.Username = "sa";
			prop.Password = "sa";
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.txtX = new System.Windows.Forms.TextBox();
			this.txtY = new System.Windows.Forms.TextBox();
			this.txtFilename = new System.Windows.Forms.TextBox();
			this.opFName = new System.Windows.Forms.OpenFileDialog();
			this.btnBrowseFName = new System.Windows.Forms.Button();
			this.btnCut = new System.Windows.Forms.Button();
			this.picWhole = new System.Windows.Forms.PictureBox();
			this.picPart = new System.Windows.Forms.PictureBox();
			this.label4 = new System.Windows.Forms.Label();
			this.txtImgID = new System.Windows.Forms.TextBox();
			this.btnLoad = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// label1
			// 
			this.label1.AutoSize = true;
			this.label1.Location = new System.Drawing.Point(16, 16);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(39, 13);
			this.label1.TabIndex = 0;
			this.label1.Text = "Image:";
			// 
			// label2
			// 
			this.label2.AutoSize = true;
			this.label2.Location = new System.Drawing.Point(16, 48);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(12, 13);
			this.label2.TabIndex = 1;
			this.label2.Text = "X";
			// 
			// label3
			// 
			this.label3.AutoSize = true;
			this.label3.Location = new System.Drawing.Point(16, 72);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(12, 13);
			this.label3.TabIndex = 2;
			this.label3.Text = "Y";
			// 
			// txtX
			// 
			this.txtX.Location = new System.Drawing.Point(64, 40);
			this.txtX.Name = "txtX";
			this.txtX.TabIndex = 2;
			this.txtX.Text = "";
			// 
			// txtY
			// 
			this.txtY.Location = new System.Drawing.Point(64, 72);
			this.txtY.Name = "txtY";
			this.txtY.TabIndex = 3;
			this.txtY.Text = "";
			// 
			// txtFilename
			// 
			this.txtFilename.Location = new System.Drawing.Point(64, 16);
			this.txtFilename.Name = "txtFilename";
			this.txtFilename.Size = new System.Drawing.Size(264, 20);
			this.txtFilename.TabIndex = 0;
			this.txtFilename.Text = "";
			// 
			// opFName
			// 
			this.opFName.Filter = "All files|*.*";
			// 
			// btnBrowseFName
			// 
			this.btnBrowseFName.Location = new System.Drawing.Point(352, 16);
			this.btnBrowseFName.Name = "btnBrowseFName";
			this.btnBrowseFName.TabIndex = 1;
			this.btnBrowseFName.Text = "Browse...";
			this.btnBrowseFName.Click += new System.EventHandler(this.btnBrowseFName_Click);
			// 
			// btnCut
			// 
			this.btnCut.Location = new System.Drawing.Point(64, 112);
			this.btnCut.Name = "btnCut";
			this.btnCut.TabIndex = 4;
			this.btnCut.Text = "Cut it up!";
			this.btnCut.Click += new System.EventHandler(this.btnCut_Click);
			// 
			// picWhole
			// 
			this.picWhole.Location = new System.Drawing.Point(280, 96);
			this.picWhole.Name = "picWhole";
			this.picWhole.Size = new System.Drawing.Size(128, 160);
			this.picWhole.TabIndex = 9;
			this.picWhole.TabStop = false;
			// 
			// picPart
			// 
			this.picPart.Location = new System.Drawing.Point(424, 88);
			this.picPart.Name = "picPart";
			this.picPart.Size = new System.Drawing.Size(144, 168);
			this.picPart.TabIndex = 10;
			this.picPart.TabStop = false;
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(16, 152);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(40, 16);
			this.label4.TabIndex = 11;
			this.label4.Text = "ImgID:";
			// 
			// txtImgID
			// 
			this.txtImgID.Location = new System.Drawing.Point(64, 152);
			this.txtImgID.Name = "txtImgID";
			this.txtImgID.Size = new System.Drawing.Size(64, 20);
			this.txtImgID.TabIndex = 12;
			this.txtImgID.Text = "";
			// 
			// btnLoad
			// 
			this.btnLoad.Location = new System.Drawing.Point(64, 184);
			this.btnLoad.Name = "btnLoad";
			this.btnLoad.TabIndex = 13;
			this.btnLoad.Text = "Load";
			this.btnLoad.Click += new System.EventHandler(this.btnLoad_Click);
			// 
			// TestMain
			// 
			this.AcceptButton = this.btnCut;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(576, 273);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
											  this.btnLoad,
											  this.txtImgID,
											  this.label4,
											  this.picPart,
											  this.picWhole,
											  this.btnCut,
											  this.btnBrowseFName,
											  this.txtFilename,
											  this.txtY,
											  this.txtX,
											  this.label3,
											  this.label2,
											  this.label1});
			this.Name = "TestMain";
			this.Text = "Form1";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new TestMain());
		}

		/// <summary>
		/// Handle the 'Browse...' button for the image filename.
		/// </summary>
		/// <param name="sender">Event sender (unused).</param>
		/// <param name="e">Event arguments (unused).</param>
		private void btnBrowseFName_Click(object sender, System.EventArgs e)
		{
			if (opFName.ShowDialog() != DialogResult.OK)
				return;
			txtFilename.Text = opFName.FileName;
		}

		/// <summary>
		/// Handle the 'Cut it up!' button.
		/// </summary>
		/// <param name="sender">Event sender (unused)</param>
		/// <param name="e">Event arguments (unused).</param>
		private void btnCut_Click(object sender, System.EventArgs e)
		{
			FileStream istr;
			Image orig;
			Image[,] pieces;
			SCImage img;
			uint x, y;
			SCDBImage db;
			int id;
			FileInfo fi;
			string sname;

			if (txtFilename.Text == String.Empty)
			{
				MessageBox.Show("You must specify a filename!",
				    "No filename",
				    MessageBoxButtons.OK,
				    MessageBoxIcon.Error);
				return;
			}
			istr = null;
			try
			{
				x = uint.Parse(txtX.Text);
				y = uint.Parse(txtY.Text);
				istr = new FileStream(txtFilename.Text, FileMode.Open);
				orig = new Bitmap(istr);
				img = new SCImage(orig);
				img.FileName = txtFilename.Text;
				fi = new FileInfo(txtFilename.Text);
				if (fi.Name.EndsWith(fi.Extension))
					sname = fi.Name.Substring(0, fi.Name.Length - fi.Extension.Length);
				else
					sname = fi.Name;
				img.Name = img.Comment = sname;
				picWhole.Image = img.Image;
				img.Cut(x, y);
				pieces = img.Pieces;
				picPart.Image = pieces[0, 0];
				img.SavePieces("D:/tmp/img/", sname);
				MessageBox.Show("Cut-up successful!");

				db = new SCDBImage();
				db.Image = img;
				db.ConnectionProperties = prop;
				id = db.StoreImage();
				MessageBox.Show("Stored into the db as " +
				    id.ToString());
				txtImgID.Text = id.ToString();
			}
			catch (Exception ex)
			{
				MessageBox.Show("Error loading the image:\n" +
				    ex.Message,
				    "Error loading the image",
				    MessageBoxButtons.OK,
				    MessageBoxIcon.Error);
			}
			finally
			{
				if (istr != null)
					istr.Close();
			}
		}

		private void btnLoad_Click(object sender, System.EventArgs e)
		{
			SCDBImage img;
			int id;

			try
			{
				if (txtImgID.Text == String.Empty)
				{
					MessageBox.Show("You must specify an image ID!",
					    "No image ID specified",
					    MessageBoxButtons.OK,
					    MessageBoxIcon.Error);
					return;
				}
				id = int.Parse(txtImgID.Text);
				img = new SCDBImage();
				img.ConnectionProperties = prop;
				img.LoadImage(id);
				txtFilename.Text = img.Image.FileName;
				txtX.Text = img.Image.Columns.ToString();
				txtY.Text = img.Image.Rows.ToString();
				picWhole.Image = img.Image.Image;
				picPart.Image = img.Image.Pieces[0, 0];
				MessageBox.Show("Image loaded successfully!");
			}
			catch (Exception ex)
			{
				MessageBox.Show("Error loading the image:\n" +
				    ex.Message,
				    "Error loading the image",
				    MessageBoxButtons.OK,
				    MessageBoxIcon.Error);
			}
		}
	}
}
